<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.system.mapper.BannerMapper">
    
    <resultMap type="Banner" id="BannerResult">
        <result property="bannerId"    column="banner_id"    />
        <result property="title"    column="title"    />
        <result property="sort"    column="sort"    />
        <result property="isDel"    column="is_del"    />
        <result property="imgUrl"    column="img_url"    />
        <result property="linkUrl"    column="link_url"    />
        <result property="content"    column="content"    />
        <result property="type"    column="type"    />
        <result property="status"    column="status"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectBannerVo">
        select banner_id, title, sort, is_del, img_url, link_url, content, type, status, create_by, create_time, update_by, update_time, remark from banner
    </sql>

    <select id="selectBannerList" parameterType="Banner" resultMap="BannerResult">
        <include refid="selectBannerVo"/>
        <where>  
            <if test="title != null  and title != ''"> and title = #{title}</if>
            <if test="sort != null "> and sort = #{sort}</if>
            <if test="isDel != null  and isDel != ''"> and is_del = #{isDel}</if>
            <if test="imgUrl != null  and imgUrl != ''"> and img_url = #{imgUrl}</if>
            <if test="linkUrl != null  and linkUrl != ''"> and link_url = #{linkUrl}</if>
            <if test="content != null  and content != ''"> and content = #{content}</if>
            <if test="type != null "> and type = #{type}</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
        </where>
        order by create_time DESC
    </select>
    
    <select id="selectBannerByBannerId" parameterType="Long" resultMap="BannerResult">
        <include refid="selectBannerVo"/>
        where banner_id = #{bannerId}
    </select>
        
    <insert id="insertBanner" parameterType="Banner" useGeneratedKeys="true" keyProperty="bannerId">
        insert into banner
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="title != null">title,</if>
            <if test="sort != null">sort,</if>
            <if test="isDel != null and isDel != ''">is_del,</if>
            <if test="imgUrl != null">img_url,</if>
            <if test="linkUrl != null">link_url,</if>
            <if test="content != null">content,</if>
            <if test="type != null">type,</if>
            <if test="status != null">status,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="title != null">#{title},</if>
            <if test="sort != null">#{sort},</if>
            <if test="isDel != null and isDel != ''">#{isDel},</if>
            <if test="imgUrl != null">#{imgUrl},</if>
            <if test="linkUrl != null">#{linkUrl},</if>
            <if test="content != null">#{content},</if>
            <if test="type != null">#{type},</if>
            <if test="status != null">#{status},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateBanner" parameterType="Banner">
        update banner
        <trim prefix="SET" suffixOverrides=",">
            <if test="title != null">title = #{title},</if>
            <if test="sort != null">sort = #{sort},</if>
            <if test="isDel != null and isDel != ''">is_del = #{isDel},</if>
            <if test="imgUrl != null">img_url = #{imgUrl},</if>
            <if test="linkUrl != null">link_url = #{linkUrl},</if>
            <if test="content != null">content = #{content},</if>
            <if test="type != null">type = #{type},</if>
            <if test="status != null">status = #{status},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where banner_id = #{bannerId}
    </update>

    <delete id="deleteBannerByBannerId" parameterType="Long">
        delete from banner where banner_id = #{bannerId}
    </delete>

    <delete id="deleteBannerByBannerIds" parameterType="String">
        delete from banner where banner_id in 
        <foreach item="bannerId" collection="array" open="(" separator="," close=")">
            #{bannerId}
        </foreach>
    </delete>
</mapper>